#include "z1.h"

#include <cmath>
#include <iostream>


struct Point {
	double x;
	double y;
	double z;
} trian_pts[3];


struct Vector {
	double x;
	double y;
	double z;
} trian_rad_vect[3], trian_vect[3];


Point create_point();
Vector create_radius_vector(Point);
Vector vector_difference(Vector, Vector);
Vector cross_product(Vector, Vector);
double vector_length(Vector);


void zadanie_1() {
	std::cout << "\t\tPerimetr\n\n";
	
	double result = 0;
	
	for (int i = 0; i < 3; ++i) {
		std::cout << "\nSet coordinates of the point " << (i + 1) << "\n";
		trian_pts[i] = create_point();
	}
	
	for (int i = 0; i < 3; ++i) {
		trian_rad_vect[i] = create_radius_vector(trian_pts[i]);
	}
	
	trian_vect[0] = vector_difference(trian_rad_vect[0], trian_rad_vect[1]);
	trian_vect[1] = vector_difference(trian_rad_vect[0], trian_rad_vect[2]);
	trian_vect[2] = vector_difference(trian_rad_vect[1], trian_rad_vect[2]);

	Vector crossProd = cross_product(trian_vect[0], trian_vect[1]);
	
	if (vector_length(crossProd)) {
		for (int i = 0; i < 3; ++i) {
			result += vector_length(trian_vect[i]);
		}
		std::cout << "\nPerimetr of the triangle is " << result << "\n";
		
	} else {
		std::cout << "\nThis is not a triangle\n";
	}
}


Point create_point() {
	Point a;
	
	std::cin >> a.x;
	std::cin >> a.y;
	std::cin >> a.z;
	
	return a;
}


Vector create_radius_vector(Point a) {
	Vector b;
	
	b.x = a.x;
	b.y = a.y;
	b.z = a.z;
	
	return b;
}


Vector vector_difference(Vector a, Vector b) {
	Vector ab;
	
	ab.x = a.x - b.x;
	ab.y = a.y - b.y; 
	ab.z = a.z - b.z;
	
	return ab;
}


Vector cross_product(Vector a, Vector b) {
	Vector c;
	
	c.x = (a.y * b.z) - (a.z * b.y);
	c.y = (a.z * b.x) - (a.x * b.z);
	c.z = (a.x * b.y) - (a.y * b.x);
	
	return c;
}


double vector_length(Vector a) {
	return (sqrt(pow(a.x, 2) + pow(a.y, 2) + pow(a.z, 2)));
}

